=== debian/changelog ===
rustc-1.90 (1.90.0+dfsg-0ubuntu1) resolute; urgency=medium

  * New upstream version 1.90.0 (LP: #2129716)
  * Standard maintenance:
    - d/patches: Refresh patches for 1.90.0 upstream
    - d/changelog: Bump version numbers
    - d/control,d/s/lintian-overrides: Update versioned package references
    - d/patches: Refresh patches after repacking upstream source
    - d/control: Update XS-Vendored-Sources-Rust
    - d/copyright: Update vendored dependency copyright stanzas
    - d/s/lintian-overrides: Update crate stub copyright Lintian overrides
  * d/p/series: Drop unneeded patches
    - Drop build/d-bootstrap-no-assume-tools.patch; now unneeded
    - Drop upstream/u-powerpc-broken-f16-tests-workaround.patch; merged
      upstream
    - Drop upstream/u-no-version-string-in-feature-removed-help.patch; merged
      upstream
  * d/prune-unused-deps: Add clippy_test_deps to workspace list
  * d/tests: Create regression autopkgtest for LP: #2100266
  * d/bin/rust-lld,d/control,d/rules,d/*.links.in: Upgrade to LLVM 21
  * d/changelog: Change version string format
  * d/bootstrap.toml.in: Omit Git hash in bootstrap
  * d/rules: Prevent duplicate call to dh_auto_build
  * d/rules: Add clippy_test_deps to workspace list
  * d/rules: Count failed test invocations as test failures

 -- Max Gilmour <max.gilmour@canonical.com>  Fri, 28 Nov 2025 07:58:33 -0800

rustc-1.89 (1.89.0+dfsg0ubuntu2-0ubuntu1) resolute; urgency=medium

  * Fix vendored dependency stub format (LP: #2132631)
    - d/prune-unused-deps: Reverse cargo-vendor-filterer overhaul
    - d/{rules,vendor-deps}: Generate dep stubs with another tarball
    - d/p/series: Remove obsolete dependency stub generation patch
    - d/add-vendored-copyright-overrides: Create script to automatically add
      the lintian overrides for all missing copyright stanzas of vendored
      crate stubs
    - d/copyright: Remove obsolete autogenerated Files-Excluded
    - d/copyright: Move vendor Files-Excluded to special component section
    - d/source/lintian-overrides: Add section for crate stub overrides
  * New upstream version 1.89.0+dfsg0ubuntu2 (repacked using new d/vendor-deps
    method)
  * d/control: Update XS-Vendored-Sources-Rust
  * d/copyright: Fix overzealous copyright stanza glob matches
  * d/source/lintian-overrides: Add copyright overrides for crate stubs

 -- Max Gilmour <max.gilmour@canonical.com>  Thu, 27 Nov 2025 15:31:31 -0800

rustc-1.89 (1.89.0+dfsg0ubuntu1-0ubuntu1) resolute; urgency=medium

  * New upstream version 1.89.0 (LP: #2121623)
  * Standard maintenance:
    - d/patches/*: refresh patches after upstream update
    - d/p/prune/d-0020-remove-windows-dependencies.patch: prune Windows
      dependencies from Rust source
    - d/control,d/s/lintian-overrides: update version numbers
    - d/copyright: update Files-Excluded with pruned vendored dependencies
    - d/patches/*: refresh patches after pruning vendored deps
    - d/control: update XS-Vendored-Sources-Rust
    - d/copyright: update vendor copyright stanzas
  * Orig tarball fixes:
    - d/copyright: exclude Enzyme benchmarks from orig tarball
    - d/copyright: comment out unneeded binary blob exclusion
  * Drop unneeded patches:
    - d/p/series: drop patches necessary only for GNU Hurd
    - d/p/series: drop upstream/u-raw-rustc-command.patch (applied upstream)
  * Remove duplicates of control files:
    - d/rules: overhaul update-version rule to work with versioned package
    - d/update-version.sh: overhaul script to update d/control and
      d/s/lintian-overrides
    - d/control.in,d/s/lintian-overrides.in: delete .in files duplicating
      existing control files
  * Automate vendored crate pruning with cargo-vendor-filterer:
    - d/prune-unused-deps: overhaul script to use cargo-vendor-filterer
    - d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: Drop obsolete
      patch manually pruning Windows dependencies
    - d/p/series,d/p/prune/d-0021-add-pruned-dep-stubs.patch: add
      autogenerated patch creating stubs for pruned deps
  * d/p/no-version-string-in-feature-removed-help.patch: don't include current
    version string in feature removed help messages (cherry-pick which will be
    applied upstream in 1.90)
  * d/p/build/d-bootstrap-tests-restrict-defaults.patch: fix incorrect field
    name for overwriting the default bootstrap test configuration
  * Point cargo wrapper script to versioned cargo instead of default
    - d/rules: add .in files in subdirectories to FILES_TO_PRECONFIGURE
    - d/rules: make preconfigured files' permissions match their originals
    - d/cargo.in: point cargo wrapper script to versioned cargo

 -- Max Gilmour <max.gilmour@canonical.com>  Fri, 17 Oct 2025 15:04:06 -0700

rustc-1.88 (1.88.0+dfsg0ubuntu1-0ubuntu1) questing; urgency=medium

  * New upstream version 1.88.0 (LP: #2120340)
  * Standard maintenance:
    - debian/patches: Early-stage patch refresh
    - d/p/prune/d-0021-vendor-remove-windows-dependencies.patch: Prune Windows
      dependencies of vendored crates
    - d/control,d/s/lintian-overrides: Update versioned identifiers
    - d/copyright: Update Files-Excluded with newly-pruned vendored crates
    - d/control,d/control.in: Update XS-Vendored-Sources-Rust
  * Drop unneeded patches:
    - d/p/upstream/u-fix-get-toml-when-test.patch: Fixed upstream
    - d/p/ubuntu/ubuntu-disable-ppc64el-asm-tests.patch: Failing tests were
      removed upstream
    - d/p/upstream/u-profiler-builtins-full-path.patch: Fixed upstream
    - d/p/upstream/u-run-make-support-dylib.patch: Fixed upstream
  * d/copyright: Update Files-Excluded list for new mdbook version
  * Fix bootstrap tests:
    - d/p/series,d/p/build/d-bootstrap-tests-restrict-defaults.patch: Restrict
      default config values for bootstrap tests
    - d/p/series,d/p/build/d-disable-git-bootstrap-tests.patch: Disable tests
      which require an upstream Git repo

 -- Max Gilmour <max.gilmour@canonical.com>  Fri, 22 Aug 2025 15:42:22 -0700


